'ESP8266 WiFi Module (IoT) By Behnam Zakizadeh @ 94.05.18 [2015]
'Update @ 95-03-20 [2016]
'www.avr64.com
'ver 2.0

$regfile = "m8adef.dat"
$crystal = 11059200
$hwstack = 32
$swstack = 32
$framesize = 32
$baud = 115200

'optional
$projecttime = 12
$version 2 , 1 , 34

'Auto set fuse bit only for ATmega8
$prog &HC0 , &HBF , &HD1 , &H00

Enable Interrupts
Enable Urxc
On Urxc Recive_s

Dim Ch As Byte
Dim S As String * 256
Dim Pos As Byte
Dim Count As Byte , Count2 As Byte
Dim S1 As String * 5
Dim Ssid As String * 32
Dim Password As String * 32
Dim Arr(350) As Byte
Dim Index As Word , Index_debug As Word
Index = 1
Dim User As String * 40 , Pass As String * 20
Dim Tmp As Byte
Dim Relay1_status As String * 3
Dim Timeout As Word

Declare Sub Gets()
Declare Sub Disp()

'Relay_1
Config Pinb.1 = Output
Relay1 Alias Portb.1

Deflcdchar 0 , 24 , 16 , 24 , 32 , 6 , 5 , 6 , 5            'CR (13 Dec)
Deflcdchar 1 , 16 , 16 , 24 , 32 , 6 , 4 , 6 , 4            'LF (10 Dec)
Deflcdchar 2 , 32 , 32 , 1 , 1 , 5 , 5 , 21 , 21            'ANTENNA

Config Lcdpin = Pin , Db4 = Portd.4 , Db5 = Portd.5 , Db6 = Portd.6 , _
 Db7 = Portd.7 , E = Portd.3 , Rs = Portd.2
Config Lcd = 16 * 2
Cursor Off Noblink
Cls

'*********************** main prog start here ************************

'CHANGE USER and PASS to your iot.avr64.com Account:

'for iot.avr64.com Account
User = "my-iotSite-usernam"                                 'iot Account Username
Pass = "my-iotSite-password"                               'iot // pass


'for ADSL Modem
Ssid = "my-adsl-SSID-name"                                  'ADSL Modem Name
Password = "my-ADSL-password"                               'ADSL Password

'***********************



Lcd "ESP8266 WiFi   " ; Chr(2)
Lowerline
Lcd "www.AVR64.com"
Wait 2

Cls : Lcd "Version:"
Lowerline : Lcd Version(2)
Wait 2


Timeout = 0

While Index = 1
   Incr Timeout
   Waitms 1
   If Timeout > 2000 Then Exit While
Wend
Call Disp()



Cls : Lcd "Init..."
Waitms 500


Timeout = 0
Index = 1

Print "AT"                                                  '[OPTIONAL] Test Module
Cls : Lcd "AT"
Wait 1

While Index = 1
   Incr Timeout
   Waitms 1
   If Timeout > 2000 Then Exit While
Wend
Call Disp()

'(
Timeout = 0
Index = 1

Print "AT+RST"                                              '[OPTIONAL] Reset
Cls : Lcd "AT+RST"
Wait 1

While Index = 1
   Incr Timeout
   Waitms 1
   If Timeout > 2000 Then Exit While
Wend
Call Disp()


Timeout = 0
Index = 1

Print "AT+GMR"                                              '[OPTIONAL] Get Firmware Version
Cls : Lcd "AT+GMR"
Wait 1

While Index = 1
   Incr Timeout
   Waitms 1
   If Timeout > 2000 Then Exit While
Wend
Call Disp()
')



Timeout = 0
Index = 1
                                                   'clear serial buffer
Print "AT+CWMODE=1"                                         'Set Station Mode
Cls : Lcd "AT+CWMODE=1"
Wait 1

While Index = 1
   Incr Timeout
   Waitms 1
   If Timeout > 2000 Then Exit While
Wend
Call Disp()



Timeout = 0
Index = 1

Print "AT+CWJAP={034}" ; Ssid ; "{034}" ; "," ; "{034}" ; Password ; "{034}"       'Connect to ADSL Modem
'{034} -> is " (double quote character)
Cls : Lcd "AT+CWJAP={034}" ; Ssid
Lowerline
Lcd "{034}" ; "," ; "{034}" ; Password ; "{034}"
Wait 10

While Index = 1
   Incr Timeout
   Waitms 1
   If Timeout > 2000 Then Exit While
Wend
Call Disp()



Timeout = 0
Index = 1

Print "AT+CWJAP?"                                           '[OPTIONAL] show connected modem
Cls : Lcd "AT+CWJAP?"
Wait 1

While Index = 1
   Incr Timeout
   Waitms 1
   If Timeout > 2000 Then Exit While
Wend
Call Disp()


Timeout = 0
Index = 1

Print "AT+CIFSR"
Cls : Lcd "AT+CIFSR"                                        '[OPTIONAL] show module IP & MAC address
Wait 1

While Index = 1
   Incr Timeout
   Waitms 1
   If Timeout > 2000 Then Exit While
Wend
Call Disp()



Timeout = 0
Index = 1

Print "AT+CIPMUX=1"
Cls : Lcd "AT+CIPMUX=1"
Wait 1

While Index = 1
   Incr Timeout
   Waitms 1
   If Timeout > 2000 Then Exit While
Wend
Call Disp()


Do

   Cls : Lcd "Connecting..."
   S = "GET /read.php?u=" + User + "&p=" + Pass + "&r=field_1 HTTP/1.1"
   Tmp = Len(s) + 25
   'Lowerline : Lcd "len(s)= " ; Tmp


   '******************* Connect To TCP Web Server & GET URL *********************
   Print "AT+CIPCLOSE=4" : Wait 1
   Print "AT+CIPSTART=4,{034}TCP{034},{034}avr64.com{034},80" : Wait 1
   Print "AT+CIPSEND=4," ; Tmp : Wait 1                     'Note: tmp is len of two below print line: len(s)+19+6   and 6 is a fixed number(three CR-LF char of three below print line)

   Print S : Wait 1
   Print "Host: iot.avr64.com" : Wait 1 : Index = 1
   Print "" : Wait 1
   '****************************************************************************



   Timeout = 0

   While Index = 1
      Incr Timeout
      Waitms 1
   If Timeout > 2000 Then Exit While
   Wend
   Call Disp()
   Call Gets()

   Lowerline

   '---------------------------------- check data come from server ------------------------------
   Cls
   Lcd "len(s)=" ; Len(s)
   Wait 1
   Cls
   Lcd S
   Wait 1

   Cls

   Pos = Instr(s , "##DATA-IS:(on)##")
   If Pos > 0 Then
      Lcd "Field_1: ON"
      Set Relay1
      Relay1_status = "on"
   End If

   Pos = Instr(s , "##DATA-IS:(off)##")
   If Pos > 0 Then
      Lcd "Field_1: OFF"
      Reset Relay1
      Relay1_status = "off"
   End If


   'now send Delivery to server:
   Wait 1



   If Relay1_status = "on" Then

      S = "GET /write.php?u=" + User + "&p=" + Pass + "&f=state_1&v=on HTTP/1.1"
      Tmp = Len(s) + 25
      'Cls : Lowerline : Lcd "len(s)= " ; Tmp

      '******************* Connect To TCP Web Server & GET URL *********************
      Print "AT+CIPCLOSE=4" : Wait 1
      Print "AT+CIPSTART=4,{034}TCP{034},{034}avr64.com{034},80" : Wait 1
      Print "AT+CIPSEND=4," ; Tmp : Wait 1

      Print S : Wait 1
      Print "Host: iot.avr64.com" : Wait 1 : Index = 1
      Print "" : Wait 1
      '****************************************************************************
   End If

   If Relay1_status = "off" Then

      S = "GET /write.php?u=" + User + "&p=" + Pass + "&f=state_1&v=off HTTP/1.1"
      Tmp = Len(s) + 25
      'Cls : Lowerline : Lcd "len(s)= " ; Tmp

      '******************* Connect To TCP Web Server & GET URL *********************
      Print "AT+CIPCLOSE=4" : Wait 1
      Print "AT+CIPSTART=4,{034}TCP{034},{034}avr64.com{034},80" : Wait 1
      Print "AT+CIPSEND=4," ; Tmp : Wait 1

      Print S : Wait 1
      Print "Host: iot.avr64.com" : Wait 1 : Index = 1
      Print "" : Wait 1
      '****************************************************************************
   End If
   '----------------------------------------------------------------------------



   '######## set Label_1 ########

   'demo for sensor simulation
   Incr Count
   S1 = Str(count)
   S1 = Format(s1 , "000")
   S = "GET /write.php?u=" + User + "&p=" + Pass + "&f=label_1&v=" + S1 + " HTTP/1.1"
   Tmp = Len(s) + 25

   Cls : Lcd "Set Label_1 to:"
   Lowerline : Lcd Count

   '******************* Connect To TCP Web Server & GET URL *********************
   Print "AT+CIPCLOSE=4" : Wait 1
   Print "AT+CIPSTART=4,{034}TCP{034},{034}avr64.com{034},80" : Wait 1
   Print "AT+CIPSEND=4," ; Tmp : Wait 1

   Print S : Wait 1
   Print "Host: iot.avr64.com" : Wait 1 : Index = 1
   Print "" : Wait 1
   '****************************************************************************


   '######## set Log_1 ########

   'demo for sensor simulation
   Incr Count2
   S1 = Str(count2)
   S1 = Format(s1 , "000")
   S = "GET /write2.php?u=" + User + "&p=" + Pass + "&v=" + S1 + " HTTP/1.1"
   Tmp = Len(s) + 25

   Cls : Lcd "add to Log_1:"
   Lowerline : Lcd Count2

   '******************* Connect To TCP Web Server & GET URL *********************
   Print "AT+CIPCLOSE=4" : Wait 1
   Print "AT+CIPSTART=4,{034}TCP{034},{034}avr64.com{034},80" : Wait 1
   Print "AT+CIPSEND=4," ; Tmp : Wait 1

   Print S : Wait 1
   Print "Host: iot.avr64.com" : Wait 1 : Index = 1
   Print "" : Wait 1
   '****************************************************************************

   Index = 1
   Wait 1
Loop

End

'_______________________________________________________________________________

Sub Gets()
   Local Indx As Word
   S = ""
   Indx = Index - 50                                        'last 50 char
   Local I As Word
   For I = Indx To Index
      S = S + Chr(arr(i))
   Next I
End Sub

'_______________________________________________________________________________

'Display big string [stored in S] on LCD, page by page.
Sub Disp()
   Local Tmp As Word , Tmp2 As Word
   Cls : Lcd Index ; " Byte Rcvd" : Wait 1 : Cls

   If Index > 1 Then
      Lcd "Module Response:"
      For Tmp = 1 To Index
         Tmp2 = Tmp Mod 16
         If Tmp2 = 0 Then
            Tmp2 = 16
         End If
         Locate 2 , Tmp2

         If Arr(tmp) >= 32 And Arr(tmp) <= 126 Then         'ASCI Char
            Lcd Chr(arr(tmp))
         Else
            Lcd " "
         End If

         If Tmp2 = 16 Then
            Wait 2
            Lowerline : Lcd Spc(16)
         End If
      Next Tmp
      Wait 2
   Else
      Lcd "Module no reply" : Wait 1
   End If


End Sub

'_______________________________________________________________________________

Recive_s:
   Incr Index_debug
   Arr(index) = Udr
   If Index < 350 Then Incr Index                           'to prevent out bound of Array
Return
'_______________________________________________________________________________


'=============================== Update History ===========================
Rem rev 1.1 [1394/06/17]

'Line 55:
'Print "AT+CWJAP={034}" + Ssid + "{034}" + "," + "{034}" + Password + "{034}"  'Connect to ADSL Modem
'Replace with:
'Print "AT+CWJAP={034}" ; Ssid ; "{034}" ; "," ; "{034}" ; Password ; "{034}"  'Connect to ADSL Modem

'Line 59:
'Print "At + Cifsr" 'show module IP & MAC address
'Replace with:
'Print "AT+CIFSR" 'show module IP & MAC address

'---------------------------------------------------

'rev 2.0
'completely changed: now bascom serial buffer not used, we use interrupt routine for receive chars instead
'because new modules receive extra bytes (bigger than buffer size -> 255 byte)
'
'Line 64:change wait 5 to Wait 10 for connecting to Lazy ADSL modem

'ver 2 @ 1395/03/20
'in this version the CIPSEND character automatically calculated and user & pass
'must be assigned in top of main prog at once.



'End Of File